/*
  Copyright 2007 FoxyTunes 
  All Rights Reserved
 */

var preferencesObserver = {
         observe : function(subject, topic, data) {
            if (topic == "nsPref:changed") {
                twittytunesReadPreferences();
            }
         }
}

var gTwittytunesPrefService = Components.classes["@mozilla.org/preferences-service;1"]
                            .getService(Components.interfaces.nsIPrefService);
var gTwittytunesPrefBranch =  gTwittytunesPrefService.getBranch("foxytunes.extras.twittytunes.")
                                .QueryInterface(Components.interfaces.nsIPrefBranch2);
var gTwittytunesExtraUtils = new ExtraUtils['1.0'];
var gTwittytunesPanel = null;

function observePrefs() {
    gTwittytunesPrefBranch.addObserver("", preferencesObserver, false);  
}

function twittytunesAttachToUI() {
    var hidden = gTwittytunesPrefBranch.getBoolPref('hidden');
    if (hidden || gTwittytunesPanel) return;

    var statusBar = document.getElementById('status-bar');
    if (!statusBar) return;
    gTwittytunesPanel = document.createElement('statusbarpanel');
    gTwittytunesPanel.setAttribute('id', 'twittytunes-statusbar-panel');
    var twittytunesButton = document.createElement('twittytunes-button');
    gTwittytunesPanel.appendChild(twittytunesButton);
    statusBar.appendChild(gTwittytunesPanel);
}

function twittytunesReadPreferences() {
    var dock = gTwittytunesExtraUtils.readSingleBoolPreference('dock', false);
    if (dock) {
        gTwittytunesPanel.parentNode.removeChild(gTwittytunesPanel);
        gTwittytunesPanel = null;
    } else {
        twittytunesAttachToUI();
    }
}

function twittytunesOverlayInit() {
    observePrefs();
    gTwittytunesExtraUtils.setPrefBranch("foxytunes.extras.twittytunes");
    var bDock = gTwittytunesExtraUtils.readSingleBoolPreference('dock', true);
    if (gTwittytunesExtraUtils.foxytunesIsInstalled() && 
        gTwittytunesExtraUtils.isExtrasSupported() &&
        bDock) {
        return;
    }
    gTwittytunesExtraUtils.writeSingleBoolPreference('dock', false);
    var ver = gTwittytunesExtraUtils.getExtensionVersion('twittytunes@extras.foxytunes.com');
    gTwittytunesExtraUtils.writeSingleCharPreference('version', ver);
    twittytunesReadPreferences();
}

function twittytunesOverlayUninit() {
    try {
        gTwittytunesPrefBranch.removeObserver("", preferencesObserver);  
    } catch (e) {};
}

addEventListener("load", twittytunesOverlayInit, false);
addEventListener("unload", twittytunesOverlayUninit, false);
