//  Copyright 2007 FoxyTunes 
//  All Rights Reserved

if (typeof(ExtensionInstaller) == "undefined") {
    var ExtensionInstaller = function() {}
}

if (typeof(ExtensionInstaller['1.0']) == "undefined") {
    ExtensionInstaller['1.0'] = function() { 
        var scriptLoader = Components.classes["@mozilla.org/moz/jssubscript-loader;1"].
                                getService(Components.interfaces.mozIJSSubScriptLoader);
        try {
            scriptLoader.loadSubScript('chrome://twittunes/content/utils/extraUtils.js');
        } catch(e) {}

        this.extraUtils = new ExtraUtils['1.0'];
        this.extraUtils.setLocalePath('chrome://twittytunes/locale/utils/utils.properties', 
                        'chrome://twittytunes/content/locale/en-US/utils/utils.properties');
    };

    ExtensionInstaller['1.0'].prototype = {
        installFromURL: function(url, title) {
            if (typeof(title) == "undefined") {
                title = this.extraUtils.getLocaleString('downloadingExtension');
            }
            var dest = Components.classes["@mozilla.org/file/directory_service;1"]
                         .getService(Components.interfaces.nsIProperties)
                         .get("TmpD", Components.interfaces.nsIFile);
            dest.append('temp-extension.xpi');
            dest.createUnique(Components.interfaces.nsIFile.NORMAL_FILE_TYPE, 0777);
    
            var io = Components.classes["@mozilla.org/network/io-service;1"]
                         .getService(Components.interfaces.nsIIOService);
            var rand = Math.random();
            var source = io.newURI(url + '?' + rand, null, null);
  
            const nsIWebBrowserPersist = Components.interfaces.nsIWebBrowserPersist;
            var persist = Components.classes["@mozilla.org/embedding/browser/nsWebBrowserPersist;1"]
                              .createInstance(nsIWebBrowserPersist);
  
            persist.persistFlags = nsIWebBrowserPersist.PERSIST_FLAGS_REPLACE_EXISTING_FILES |
                               nsIWebBrowserPersist.PERSIST_FLAGS_NO_CONVERSION | 
                               nsIWebBrowserPersist.PERSIST_FLAGS_BYPASS_CACHE;

            this.progressListener.canceled = false;
            this.progressListener.outer = this;
            this.progressListener.persist = persist;
            this.progressListener.destFile = dest;
            persist.progressListener = this.progressListener;
 
            this.progressDialog = window.openDialog("chrome://twittytunes/content/utils/progressDialog.xul",
                          "extProgress", "chrome,centerscreen,dependent", 
                          {status: title, progress: 0, listener: this.progressListener } );
 
            persist.saveURI(source, null, null, null, null, dest);
        },

        installFromLocalFile: function(localFilename) {
            var file = Components.classes["@mozilla.org/file/local;1"].
                         createInstance(Components.interfaces.nsILocalFile);
            file.initWithPath(localFilename); 
            var extensionManager = Components.classes["@mozilla.org/extensions/manager;1"]
                           .getService(Components.interfaces.nsIExtensionManager);
            var rc = false;
            try {
              extensionManager.installItemFromFile(file, "app-profile");
              rc = true;
            } catch (e) {}
            return rc;
        },

        restartApp: function() {
            const nsIAppStartup = Components.interfaces.nsIAppStartup;

            // Notify all windows that an application quit has been requested.
           var os = Components.classes["@mozilla.org/observer-service;1"]
                          .getService(Components.interfaces.nsIObserverService);
           var cancelQuit = Components.classes["@mozilla.org/supports-PRBool;1"]
                          .createInstance(Components.interfaces.nsISupportsPRBool);
           os.notifyObservers(cancelQuit, "quit-application-requested", null);

           // Something aborted the quit process. 
           if (cancelQuit.data)
             return;

           // Notify all windows that an application quit has been granted.
           os.notifyObservers(null, "quit-application-granted", null);

           // Enumerate all windows and call shutdown handlers
           var wm = Components.classes["@mozilla.org/appshell/window-mediator;1"]
                          .getService(Components.interfaces.nsIWindowMediator);
           var windows = wm.getEnumerator(null);
           while (windows.hasMoreElements()) {
               var win = windows.getNext();
               if (("tryToClose" in win) && !win.tryToClose())
                   return;
           }
           Components.classes["@mozilla.org/toolkit/app-startup;1"].getService(nsIAppStartup)
                 .quit(nsIAppStartup.eRestart | nsIAppStartup.eAttemptQuit);
     }
    }

    ExtensionInstaller['1.0'].prototype.progressListener = {
            onLocationChange : function(webProgress, request, location) {}, 

            onProgressChange : function(webProgress, 
                                  request, 
                                  curSelfProgress, 
                                  maxSelfProgress, 
                                  curTotalProgress, 
                                  maxTotalProgress) {
                var percentage = curSelfProgress/maxSelfProgress*100;
                if (this.observer) {
                    this.observer.onProgressChange(percentage);
                }
            },

            onSecurityChange : function (webProgress, request, state) {},
    
            onStateChange : function(webProgress, request, stateFlags, status) {
                if (this.canceled) {
                    return;
                }

                if (!(stateFlags & Components.interfaces.nsIWebProgressListener.STATE_STOP)) return;

                try {
                    if (this.outer.progressDialog) this.outer.progressDialog.close();
                } catch(e) {};

                var promptService = Components.classes["@mozilla.org/embedcomp/prompt-service;1"].
                                           getService(Components.interfaces.nsIPromptService);
                var bShowError = false;
                try {
                    if (this.destFile.exists()) {
                        var rc = this.outer.installFromLocalFile(this.destFile.path);
                        if (rc) {
                            var flags = promptService.BUTTON_POS_0 * promptService.BUTTON_TITLE_IS_STRING +
                                        promptService.BUTTON_POS_1 * promptService.BUTTON_TITLE_IS_STRING;        
                            var check = {value: false}; 
                            var title = this.outer.extraUtils.getLocaleString('installationCompleted');
                            var header = this.outer.extraUtils.getLocaleString('restartToCompleteInstallation');
                            var restartButtonTxt = this.outer.extraUtils.getLocaleString('restart');
                            var laterButtonTxt = this.outer.extraUtils.getLocaleString('later');
                            var ret = promptService.confirmEx(null, title, header, 
                                                              flags, restartButtonTxt,laterButtonTxt, "", null, check);
                            // Restart Firefox
                            if (ret == 0) {
                                this.outer.restartApp();
                            }
                        } else {
                            bShowError = true;
                        }
                    } else {
                        bShowError = true;
                    }
                } catch (e) {
                    bShowError = true;
                    dump('download exception: ' + e + '\n');
                }
                if (bShowError) {
                    var title = this.outer.extraUtils.getLocaleString('downlowdErrorTitle');
                    var body = this.outer.extraUtils.getLocaleString('errorWhileInstallingExtension');
                    var result = promptService.alert(null, title, body);
                }
            },

            onStatusChange : function (webProgress, request, status, message) {},

            // for progress dialog use
            setObserver : function(observer) {
                this.observer = observer;
            },

            cancelTransfer : function() {
                this.persist.cancel(1);
                this.destFile.remove(false);
                this.canceled = true;
            }
    }
}
